//
//  ViewController.m
//  选择列表
//
//  Created by 赵治亮 on 2018/6/1.
//  Copyright © 2018年 赵治亮. All rights reserved.
//
#define SCREEN_WIDTH   [UIScreen mainScreen].bounds.size.width


#import "ViewController.h"
#import "CollectionReusableView.h"
@interface ViewController ()<UICollectionViewDelegate,UICollectionViewDataSource,UICollectionViewDelegateFlowLayout>
@property (nonatomic, strong) UICollectionView *myCollectionView;
//按钮金额数组
@property (nonatomic,strong)NSArray *moneyArr;
//选中后添加的数组
@property (nonatomic,strong)NSMutableArray *rightLabelArray;
@end

@implementation ViewController

- (void)viewDidLoad {
    [super viewDidLoad];

    _moneyArr = @[@[@"1",@"2",@"3",@"4",@"5",@"6",@"7",@"8"],@[@"1",@"2",@"3",@"4",@"5",@"6",@"7",@"8"]];
    _rightLabelArray = [NSMutableArray array];

    for (int i = 0; i<_moneyArr.count; i++) {
        [_rightLabelArray addObject:@""];
    }


    UICollectionViewFlowLayout *flowLayout = [[UICollectionViewFlowLayout alloc]init];
    //section内置大小
    flowLayout.sectionInset = UIEdgeInsetsMake(10, 25, 10, 25);

    //默认最小为10 如果比10小 需要重新赋值
    //    flowLayout.minimumInteritemSpacing = 5;

    //行间距
    flowLayout.minimumLineSpacing = 5;

    //item大小 如果只有一种size 不适用代理方法返回大小
    //    flowLayout.itemSize = CGSizeMake((SCREEN_WIDTH - 30)/ 3, 200);

    //预估算,节省时间
    //多种item大小 使用estimatedItemSize提高代码运算效率,提高流畅度
    //flowLayout.estimatedItemSize = CGSizeMake(((SCREEN_WIDTH - 20) + (SCREEN_WIDTH - 30)/3)/2, 200);


    //设置header大小
    flowLayout.headerReferenceSize = CGSizeMake(SCREEN_WIDTH, 50);
    //    flowLayout.sectionHeadersPinToVisibleBounds = YES;
    //    flowLayout.footerReferenceSize = CGSizeMake(SCREEN_WIDTH, 50);



    UICollectionView *collection = [[UICollectionView alloc]initWithFrame:self.view.frame collectionViewLayout:flowLayout];

    //设置允许多选
    collection.allowsMultipleSelection = YES;
    //签代理
    collection.delegate = self;
    collection.dataSource = self;
    collection.backgroundColor = [UIColor whiteColor];
    //注册
    [collection registerClass:[UICollectionViewCell class] forCellWithReuseIdentifier:@"UICollectionViewCell"];
    [self.view addSubview:collection];

    //头部区域 底部区域 同cell一样遵循重用机制
    [collection registerClass:[CollectionReusableView class] forSupplementaryViewOfKind:UICollectionElementKindSectionHeader withReuseIdentifier:@"UICollectionReusableView"];

    [collection registerClass:[UICollectionReusableView class] forSupplementaryViewOfKind:UICollectionElementKindSectionFooter withReuseIdentifier:@"UICollectionReusable"];




}



#pragma mark - collection delegate/dataSource

- (NSInteger)numberOfSectionsInCollectionView:(UICollectionView *)collectionView{

//    return 3;

    return _moneyArr.count;

}

- (NSInteger)collectionView:(UICollectionView *)collectionView numberOfItemsInSection:(NSInteger)section{
    return [_moneyArr[section] count];

//    if (section == 0) {
//        return 1;
//    }else if (section == 1){
//        return 4;
//
//    }else{
//
//        return 5;
//    }

}

- (UICollectionViewCell *)collectionView:(UICollectionView *)collectionView cellForItemAtIndexPath:(NSIndexPath *)indexPath{

    UICollectionViewCell *cell = [collectionView dequeueReusableCellWithReuseIdentifier:@"UICollectionViewCell" forIndexPath:indexPath];

//            cell.backgroundColor = [UIColor grayColor];


   // cell.textLable.text =_moneyArr[indexPath.item];
    // 选中一个的方法
    if (_rightLabelArray.count ==0) {
        // 第一次加载的方法
        if (indexPath.row ==0 ) {
            cell.backgroundColor = [UIColor redColor];
        }else{
            cell.backgroundColor = [UIColor greenColor];
        }
    }else{
        if ([_rightLabelArray[indexPath.section] isEqualToString :_moneyArr[indexPath.section][indexPath.row]]) {
            cell.backgroundColor = [UIColor redColor];
        } else {
            cell.backgroundColor = [UIColor greenColor];
        }
    }
    return cell;


//    if (cell.isSelected) {
//        cell.backgroundColor = [UIColor grayColor];
//    }else{
//        cell.backgroundColor = [UIColor orangeColor];
//
//    }
//
//
//
//    return cell;


}
#pragma mark -
//collView学名是集合视图  tableView是表视图
//collView中的foot header 是曽补视图

- (UICollectionReusableView *)collectionView:(UICollectionView *)collectionView viewForSupplementaryElementOfKind:(NSString *)kind atIndexPath:(NSIndexPath *)indexPath{

    if (kind == UICollectionElementKindSectionHeader ) {
        CollectionReusableView *reusableView = [collectionView dequeueReusableSupplementaryViewOfKind:kind withReuseIdentifier:@"UICollectionReusableView" forIndexPath:indexPath];
        reusableView.backgroundColor = [UIColor redColor];

        return reusableView;

    }else{

        UICollectionReusableView *reusable = [collectionView dequeueReusableSupplementaryViewOfKind:kind withReuseIdentifier:@"UICollectionReusable" forIndexPath:indexPath];

        reusable.backgroundColor = [UIColor blackColor];

        return reusable;

    }


}

//判断分区,可以直接签代理 或者进入flowlayout里直接复制方法
- (CGSize)collectionView:(UICollectionView *)collectionView layout:(UICollectionViewLayout *)collectionViewLayout sizeForItemAtIndexPath:(NSIndexPath *)indexPath{

//    if (indexPath.section == 0) {
//        NSLog(@"1111111");
//        return CGSizeMake(375, 200);
//
//    }else  if (indexPath.section == 1){

        return CGSizeMake(SCREEN_WIDTH / 3 - 50 , SCREEN_WIDTH / 3 - 50);

//    }else{
//
//        return CGSizeMake(SCREEN_WIDTH - 20 , 200);
//    }

}

- (void)collectionView:(UICollectionView *)collectionView didSelectItemAtIndexPath:(NSIndexPath *)indexPath{




   // NSLog(@"%zd",indexPath.row);
    //点击后添加因为只需要一个所以直接初始化掉重新赋值
    _rightLabelArray[indexPath.section] = _moneyArr[indexPath.section][indexPath.row];

    NSLog(@"rightLabelArray=====%@",_rightLabelArray);
    [collectionView reloadData];



    //    indexPath.item;
    //    _rightLabelArray = [NSMutableArray arrayWithObject:_moneyArr[]  [indexPath.item]];

//    NSLog(@"section====%ld row===%ld",indexPath.section,(long)indexPath.row);
//    //根据idenxPath获取对应的cell
//    NSIndexSet *insexset = [NSIndexSet indexSetWithIndex:indexPath.section];
//    NSLog(@"%@",insexset);
//    UICollectionViewCell *cell =  [collectionView cellForItemAtIndexPath:indexPath];
//    if(cell.selected){
//        cell.backgroundColor = [UIColor grayColor];
//    }else{
//
//     cell.backgroundColor = [UIColor greenColor];
//    }
//
//    [collectionView reloadData];
}


- (void)collectionView:(UICollectionView *)collectionView didDeselectItemAtIndexPath:(NSIndexPath *)indexPath{
    UICollectionViewCell *cell =  [collectionView cellForItemAtIndexPath:indexPath];
    cell.backgroundColor = [UIColor orangeColor];

}



- (void)didReceiveMemoryWarning {
    [super didReceiveMemoryWarning];
    
}


@end
